/******************************************************************************
 * File Name    : TeacherInfoWindow.h
 * Created      : 2008/9/10
 * Author       : lfeng@neusoft.com
 * Model        :
 * Description  : The header file of TeacherInfoWindow
 ******************************************************************************/
#ifndef TEACHERINFOWINDOW_H_
#define TEACHERINFOWINDOW_H_
#include <gtk/gtk.h>
#include "libsesdata.h"
//#include "seslib.h"
//#include "SESCommonDef.h"
#include "libsesgui.h"
class TeacherInfoWindow: public IPCAPI::CTeacherAPICallbackBase
{
public:
	TeacherInfoWindow();
	virtual ~TeacherInfoWindow();
	void Init();
	void Close();
	bool HasInvalidCharacters(std::string&);
	static void OkBtnClickedStatic(GtkWidget* widget, gpointer data);
	static void CancelBtnClickedStatic(GtkWidget* widget, gpointer data);
	static bool WindowClosing(GtkWidget*, GdkEvent*, gpointer);
	void ShowModal(GtkWidget* parenWindow, GCallback cb, gpointer data);
private:
	void CreateWindow();
	GtkWidget* CreateTreeView();
	bool CompareOriginalData();

private:
	GtkWidget* m_gWindow;
	GtkWidget* m_gCourseNameEntry;
	GtkWidget* m_gTeacherNameEntry;

	string m_pOriginalTeacherName;
	string m_pOriginalCourseName;



	LibSESData::CTeacherInfoData m_pTeacherInfoData;

	std::string m_teacherName;
	std::string m_courseName;


};

#endif /* TEACHERINFOWINDOW_H_ */
